## kloak 0.4.0

=== Makefile ===
#!/usr/bin/make -f

CC         ?= gcc
INSTALL    ?= install
PKG_CONFIG ?= pkg-config
RONN       ?= ronn

CFLAGS     ?= -O2 -g

# NOTE: The systemd unit and apparmor profile are hardcoded to use
#       /usr/sbin/kloak. So if you change the default install paths,
#       you will have to patch those files yourself.
prefix         ?= /usr
sbindir        ?= $(prefix)/sbin
datadir        ?= $(prefix)/share
mandir         ?= $(datadir)/man

udev_rules_dir ?= /lib/udev/rules.d
apparmor_dir   ?= /etc/apparmor.d/
systemd_dir    ?= /usr/lib/systemd/system

TARGETARCH=$(shell $(CC) -dumpmachine)
CC_VERSION=$(shell $(CC) --version)

# https://best.openssf.org/Compiler-Hardening-Guides/Compiler-Options-Hardening-Guide-for-C-and-C++.html
#
# Omitted the following flags:
# -D_GLIBCXX_ASSERTIONS  # application is not written in C++
# -fstrict-flex-arrays=3 # not supported in Debian Bookworm's GCC version (12)
# -fPIC -shared          # not a shared library
# -fexceptions           # not multithreaded
# -fhardened             # not supported in Debian Bookworm's GCC version (12)
#
# Added the following flags:
# -fsanitize=address,undefined # enable ASan/UBSan
WARN_CFLAGS := -Wall -Wformat -Wformat=2 -Wconversion -Wimplicit-fallthrough \
	-Werror=format-security -Werror=implicit -Werror=int-conversion \
	-Werror=incompatible-pointer-types

ifeq (,$(findstring clang,$(CC_VERSION))) # if not clang
WARN_CFLAGS += -Wtrampolines -Wbidi-chars=any  # clang as for 18.1.8 doesn't support this warnings
endif

FORTIFY_CFLAGS := -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=3 -fstack-clash-protection \
	-fstack-protector-strong -fno-delete-null-pointer-checks \
	-fno-strict-overflow -fno-strict-aliasing -fsanitize=undefined

ifeq (yes,$(patsubst x86_64%-linux-gnu,yes,$(TARGETARCH)))
FORTIFY_CFLAGS += -fcf-protection=full # only supported on x86_64
endif
ifeq (yes,$(patsubst aarch64%-linux-gnu,yes,$(TARGETARCH)))
FORTIFY_CFLAGS += -mbranch-protection=standard # only supported on aarch64
endif

BIN_CFLAGS := -fPIE

CFLAGS := $(WARN_CFLAGS) $(FORTIFY_CFLAGS) $(BIN_CFLAGS) $(CFLAGS)
LDFLAGS := -Wl,-z,nodlopen -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now \
	-Wl,--as-needed -Wl,--no-copy-dt-needed-entries -pie $(LDFLAGS)

ifeq (, $(shell which $(PKG_CONFIG)))
$(error pkg-config not installed!)
endif

all : kloak eventcap

kloak : src/main.c src/keycodes.c src/keycodes.h
	$(CC) src/main.c src/keycodes.c -o kloak -lm $(shell $(PKG_CONFIG) --cflags --libs libevdev) $(shell $(PKG_CONFIG) --cflags --libs libsodium) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS)

eventcap : src/eventcap.c
	$(CC) src/eventcap.c -o eventcap $(CPPFLAGS) $(CFLAGS) $(LDFLAGS)

MANPAGES := auto-generated-man-pages/eventcap.8 auto-generated-man-pages/kloak.8

man : $(MANPAGES)

auto-generated-man-pages/% : man/%.ronn
	ronn --manual="kloak Manual" --organization="kloak" <$< >$@

clean :
	rm -f kloak eventcap

install : all lib/udev/rules.d/95-kloak.rules etc/apparmor.d/usr.sbin.kloak  usr/lib/systemd/system/kloak.service $(MANPAGES)
	$(INSTALL) -d -m 755 $(addprefix $(DESTDIR), $(sbindir) $(mandir)/man8 $(udev_rules_dir) $(apparmor_dir) $(systemd_dir))
	$(INSTALL) -m 755 kloak eventcap $(DESTDIR)$(sbindir)
	$(INSTALL) -m 644 $(MANPAGES) $(DESTDIR)$(mandir)/man8
	$(INSTALL) -m 644 lib/udev/rules.d/95-kloak.rules $(DESTDIR)$(udev_rules_dir)
	$(INSTALL) -m 644 etc/apparmor.d/usr.sbin.kloak $(DESTDIR)$(apparmor_dir)
	$(INSTALL) -m 644 usr/lib/systemd/system/kloak.service $(DESTDIR)$(systemd_dir)

=== debian/changelog ===
kloak (0:0.4.0-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Fri, 24 Jan 2025 13:21:51 +0000

kloak (0:0.3.9-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Tue, 31 Dec 2024 19:26:41 +0000

kloak (0:0.3.8-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Thu, 21 Nov 2024 12:20:03 +0000

kloak (0:0.3.7-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Thu, 07 Nov 2024 16:04:07 +0000

kloak (0:0.3.6-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Sun, 06 Oct 2024 14:01:58 +0000

kloak (0:0.3.5-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Fri, 27 Sep 2024 00:48:20 +0000

kloak (0:0.3.4-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Thu, 26 Sep 2024 11:07:01 +0000

kloak (0:0.3.3-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Wed, 25 Sep 2024 04:23:39 +0000

kloak (0:0.3.2-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Wed, 25 Sep 2024 04:16:46 +0000

kloak (0:0.3.1-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Wed, 25 Sep 2024 01:04:05 +0000

kloak (0:0.3.0-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Tue, 24 Sep 2024 05:03:38 +0000

kloak (0:0.2.53-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Tue, 24 Sep 2024 05:00:47 +0000

kloak (0:0.2.52-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Fri, 02 Feb 2024 12:46:16 +0000

kloak (0:0.2.51-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Mon, 22 Jan 2024 13:25:12 +0000

kloak (0:0.2.50-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Thu, 11 Jan 2024 13:05:14 +0000

kloak (0:0.2.49-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Sat, 11 Nov 2023 20:30:12 +0000

kloak (0:0.2.48-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Mon, 25 Sep 2023 15:58:40 +0000

kloak (0:0.2.47-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Sun, 24 Sep 2023 15:22:09 +0000

kloak (0:0.2.46-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Mon, 18 Sep 2023 11:23:20 +0000

kloak (0:0.2.45-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Wed, 16 Aug 2023 10:51:58 +0000

kloak (0:0.2.44-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Tue, 15 Aug 2023 13:21:16 +0000

kloak (0:0.2.41-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Tue, 15 Aug 2023 13:08:18 +0000

kloak (0:0.2.40-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Tue, 15 Aug 2023 12:19:56 +0000

kloak (0:0.2.39-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Sun, 09 Jul 2023 10:32:50 +0000

kloak (0:0.2.38-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Sun, 09 Jul 2023 09:32:55 +0000

kloak (0:0.2.37-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Sat, 08 Jul 2023 00:08:03 +0000

kloak (0:0.2.36-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Wed, 21 Jun 2023 09:43:23 +0000

kloak (0:0.2.35-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Fri, 16 Jun 2023 11:28:58 +0000

kloak (0:0.2.34-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Wed, 14 Jun 2023 10:09:18 +0000

kloak (0:0.2.33-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Mon, 12 Jun 2023 18:15:43 +0000

kloak (0:0.2.32-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Mon, 12 Jun 2023 15:38:28 +0000

kloak (0:0.2.31-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Wed, 25 May 2022 10:07:59 +0000

kloak (0:0.2.30-2) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Sun, 12 Sep 2021 15:42:44 +0000

kloak (0:0.2.30-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Sat, 28 Aug 2021 17:53:51 +0000

kloak (0:0.2.29-2) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Thu, 05 Aug 2021 20:47:52 +0000

kloak (0:0.2.29-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Thu, 18 Mar 2021 13:05:55 +0000


=== debian/control ===
## Copyright (C) 2012 - 2025 ENCRYPTED SUPPORT LLC <adrelanos@whonix.org>
## See the file COPYING for copying conditions.

Source: kloak
Section: misc
Priority: optional
Maintainer: Patrick Schleizer <adrelanos@whonix.org>
Build-Depends: debhelper (>= 13.11.4), debhelper-compat (= 13), dh-apparmor, libevdev2, libevdev-dev, libsodium23, libsodium-dev, pkg-config
Homepage: https://github.com/vmonaco/kloak
Vcs-Browser: https://github.com/vmonaco/kloak
Vcs-Git: https://github.com/vmonaco/kloak.git
Standards-Version: 4.6.2
Rules-Requires-Root: no

Package: kloak
## Related tickets:
## https://github.com/vmonaco/kloak/issues/24
## https://github.com/vmonaco/kloak/issues/25
##
## Bug:
## Actually building might be possible but cross building using qemu has issues:
## https://github.com/vivier/qemu-m68k/issues/38
## Update: in above link it is being said that it was fixed.
## Could try again in Debian bullseye or above.
##
## Bug:
## https://bugs.launchpad.net/qemu/+bug/1756519
## https://bugs.launchpad.net/qemu/+bug/1793539
## qemu:handle_cpu_signal received signal outside vCPU context @ pc=0x60269d8c
## qemu:handle_cpu_signal received signal outside vCPU context @ pc=0x6000178c
## Update: Same as above.
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libevdev2, libsodium23
Description: anti keystroke deanonymization tool
 A keystroke-level online anonymization kernel.
 .
 A privacy tool that makes keystroke biometrics less effective. This
 is accomplished by obfuscating the time intervals between key press and
 release events, which are typically used for identification.

=== debian/rules ===
#!/usr/bin/make -f

## Copyright (C) 2016 - 2025 ENCRYPTED SUPPORT LLC <adrelanos@whonix.org>
## See the file COPYING for copying conditions.

export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

APPARMOR_PROFILE_NAME=$(shell basename $$(echo ./etc/apparmor.d/*.*))

override_dh_installman:
	dh_installman $(CURDIR)/debian/eventcap.8
	dh_installman $(CURDIR)/debian/kloak.8

override_dh_installchangelogs:
	dh_installchangelogs changelog.upstream upstream

override_dh_install:
	dh_apparmor --profile-name=$(APPARMOR_PROFILE_NAME) -p$(shell dh_listpackages)
	dh_install

=== debian/watch ===
## Copyright (C) 2012 - 2025 ENCRYPTED SUPPORT LLC <adrelanos@whonix.org>
## See the file COPYING for copying conditions.

version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/kloak-$1\.tar\.gz/ \
  https://github.com/Whonix/kloak/tags .*/v?(\d\S+)\.tar\.gz

## kloak 0.5.3

=== Makefile ===
#!/usr/bin/make -f

CC         ?= gcc
INSTALL    ?= install
PKG_CONFIG ?= pkg-config
RONN       ?= ronn

CFLAGS     ?= -O2 -g

# NOTE: The apparmor profile is hardcoded to use /usr/bin/kloak. So if you
#       change the default install paths, you will have to patch those files
#       yourself.
prefix         ?= /usr
bindir         ?= $(prefix)/bin
datadir        ?= $(prefix)/share
mandir         ?= $(datadir)/man
apparmor_dir   ?= /etc/apparmor.d/

TARGETARCH=$(shell $(CC) -dumpmachine)
CC_VERSION=$(shell $(CC) --version)

# https://best.openssf.org/Compiler-Hardening-Guides/Compiler-Options-Hardening-Guide-for-C-and-C++.html
#
# Omitted the following flags:
# -D_GLIBCXX_ASSERTIONS  # application is not written in C++
# -fPIC -shared          # not a shared library
# -fexceptions           # not multithreaded
# -fhardened             # superfluous when building an apt package
#
# Added the following flags:
# -fsanitize=address,undefined # enable ASan/UBSan
# -ftrapv                      # Crash on signed integer overflow/underflow
# lots of additional warning flags and hardening
WARN_CFLAGS := -Wall -Wextra -Wformat -Wformat=2 -Wconversion \
	-Wimplicit-fallthrough -Werror=format-security -Werror=implicit \
	-Werror=int-conversion -Werror=incompatible-pointer-types \
	-Wformat-overflow -Wformat-signedness -Wformat-truncation \
	-Wnull-dereference -Winit-self -Wmissing-include-dirs \
	-Wshift-negative-value -Wshift-overflow -Wswitch-default \
	-Wuninitialized -Walloca -Warray-bounds -Wfloat-equal -Wshadow \
	-Wpointer-arith -Wundef -Wunused-macros -Wbad-function-cast -Wcast-qual \
	-Wcast-align -Wwrite-strings -Wdate-time -Wstrict-prototypes \
	-Wold-style-definition -Wredundant-decls -Winvalid-utf8 -Wvla \
	-Wdisabled-optimization -Wstack-protector -Wdeclaration-after-statement

ifeq (,$(findstring clang,$(CC_VERSION))) # if not clang
# clang as for 19.1.0 doesn't support these warnings
WARN_CFLAGS += -Wtrampolines -Wbidi-chars=any,ucn -Wformat-overflow=2 \
	-Wformat-truncation=2 -Wshift-overflow=2 -Wtrivial-auto-var-init \
	-Wstringop-overflow=3 -Wstrict-flex-arrays -Walloc-zero \
	-Warray-bounds=2 -Wattribute-alias=2 \
	-Wduplicated-branches -Wduplicated-cond	-Wcast-align=strict \
	-Wjump-misses-init -Wlogical-op
endif

#ifeq (,$(findstring clang,$(CC_VERSION))) # if clang
#WARN_CFLAGS +=  #
#endif

FORTIFY_CFLAGS := -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=3 \
	-fstack-clash-protection -fstack-protector-all \
	-fno-delete-null-pointer-checks -fno-strict-overflow -fno-strict-aliasing \
	-fsanitize=address,undefined -fno-sanitize-recover=all \
	-fstrict-flex-arrays=3

ifeq (yes,$(patsubst x86_64%-linux-gnu,yes,$(TARGETARCH)))
FORTIFY_CFLAGS += -fcf-protection=full # only supported on x86_64
endif
ifeq (yes,$(patsubst aarch64%-linux-gnu,yes,$(TARGETARCH)))
FORTIFY_CFLAGS += -mbranch-protection=standard # only supported on aarch64
endif

BIN_CFLAGS := -fPIE

CFLAGS := $(WARN_CFLAGS) $(FORTIFY_CFLAGS) $(BIN_CFLAGS) $(CFLAGS)
LDFLAGS := -Wl,-z,nodlopen -Wl,-z,noexecstack -Wl,-z,relro -Wl,-z,now \
	-Wl,--as-needed -Wl,--no-copy-dt-needed-entries -pie $(LDFLAGS)

ifeq (, $(shell which $(PKG_CONFIG)))
$(error pkg-config not installed!)
endif

all : kloak

kloak : src/kloak.c src/kloak.h src/xdg-shell-protocol.h src/xdg-shell-protocol.c src/xdg-output-protocol.h src/xdg-output-protocol.c src/wlr-layer-shell.c src/wlr-layer-shell.h src/wlr-virtual-pointer.c src/wlr-virtual-pointer.h src/virtual-keyboard.c src/virtual-keyboard.h
	$(CC) -g src/kloak.c src/xdg-shell-protocol.c src/xdg-output-protocol.c src/wlr-layer-shell.c src/wlr-virtual-pointer.c src/virtual-keyboard.c -o kloak -lm -lrt $(shell $(PKG_CONFIG) --cflags --libs libinput) $(shell $(PKG_CONFIG) --cflags --libs libevdev) $(shell $(PKG_CONFIG) --cflags --libs wayland-client) $(shell $(PKG_CONFIG) --cflags --libs xkbcommon) $(CFLAGS) $(LDFLAGS)

src/xdg-shell-protocol.h : protocol/xdg-shell.xml
	wayland-scanner client-header < protocol/xdg-shell.xml > src/xdg-shell-protocol.h

src/xdg-shell-protocol.c : protocol/xdg-shell.xml
	wayland-scanner private-code < protocol/xdg-shell.xml > src/xdg-shell-protocol.c

src/xdg-output-protocol.h : protocol/xdg-output-unstable-v1.xml
	wayland-scanner client-header < protocol/xdg-output-unstable-v1.xml > src/xdg-output-protocol.h

src/xdg-output-protocol.c : protocol/xdg-output-unstable-v1.xml
	wayland-scanner private-code < protocol/xdg-output-unstable-v1.xml > src/xdg-output-protocol.c

src/wlr-layer-shell.h : protocol/wlr-layer-shell-unstable-v1.xml
	wayland-scanner client-header < protocol/wlr-layer-shell-unstable-v1.xml > src/wlr-layer-shell.h

src/wlr-layer-shell.c : protocol/wlr-layer-shell-unstable-v1.xml
	wayland-scanner private-code < protocol/wlr-layer-shell-unstable-v1.xml > src/wlr-layer-shell.c

src/wlr-virtual-pointer.h : protocol/wlr-virtual-pointer-unstable-v1.xml
	wayland-scanner client-header < protocol/wlr-virtual-pointer-unstable-v1.xml > src/wlr-virtual-pointer.h

src/wlr-virtual-pointer.c : protocol/wlr-virtual-pointer-unstable-v1.xml
	wayland-scanner private-code < protocol/wlr-virtual-pointer-unstable-v1.xml > src/wlr-virtual-pointer.c

src/virtual-keyboard.h : protocol/virtual-keyboard-unstable-v1.xml
	wayland-scanner client-header < protocol/virtual-keyboard-unstable-v1.xml > src/virtual-keyboard.h

src/virtual-keyboard.c : protocol/virtual-keyboard-unstable-v1.xml
	wayland-scanner private-code < protocol/virtual-keyboard-unstable-v1.xml > src/virtual-keyboard.c

MANPAGES := auto-generated-man-pages/kloak.8

man : $(MANPAGES)

auto-generated-man-pages/% : man/%.ronn
	ronn --manual="kloak Manual" --organization="kloak" <$< >$@

clean :
	rm -f kloak
	rm -f src/xdg-shell-protocol.h src/xdg-shell-protocol.c src/xdg-output-protocol.h src/xdg-output-protocol.c src/wlr-layer-shell.h src/wlr-layer-shell.c src/wlr-virtual-pointer.h src/wlr-virtual-pointer.c src/virtual-keyboard.h src/virtual-keyboard.c

install : all etc/apparmor.d/usr.bin.kloak $(MANPAGES)
	$(INSTALL) -d -m 755 $(addprefix $(DESTDIR), $(bindir) $(mandir)/man8 $(apparmor_dir))
	$(INSTALL) -m 755 kloak $(DESTDIR)$(bindir)
	$(INSTALL) -m 644 $(MANPAGES) $(DESTDIR)$(mandir)/man8
	$(INSTALL) -m 644 etc/apparmor.d/usr.bin.kloak $(DESTDIR)$(apparmor_dir)

=== debian/changelog ===
kloak (0:0.5.3-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Fri, 03 Oct 2025 14:02:53 +0000

kloak (0:0.5.2-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Sun, 28 Sep 2025 21:13:04 +0000

kloak (0:0.5.1-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Fri, 26 Sep 2025 09:35:49 +0000

kloak (0:0.5.0-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Mon, 22 Sep 2025 17:31:59 +0000

kloak (0:0.4.9-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Fri, 19 Sep 2025 18:12:23 +0000

kloak (0:0.4.8-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Sat, 13 Sep 2025 10:34:44 +0000

kloak (0:0.4.7-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Sat, 13 Sep 2025 10:24:51 +0000

kloak (0:0.4.6-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Tue, 02 Sep 2025 15:36:13 +0000

kloak (0:0.4.5-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Tue, 02 Sep 2025 14:06:24 +0000

kloak (0:0.4.4-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Sat, 30 Aug 2025 15:05:24 +0000

kloak (0:0.4.3-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Tue, 26 Aug 2025 09:39:38 +0000

kloak (0:0.4.2-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Tue, 26 Aug 2025 09:36:57 +0000

kloak (0:0.4.1-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Tue, 26 Aug 2025 09:30:42 +0000

=== debian/control ===
--- 
+++ 
@@ -5,11 +5,18 @@
 Section: misc
 Priority: optional
 Maintainer: Patrick Schleizer <adrelanos@whonix.org>
-Build-Depends: debhelper (>= 13.11.4), debhelper-compat (= 13), dh-apparmor, libevdev2, libevdev-dev, libsodium23, libsodium-dev, pkg-config
+Build-Depends: debhelper (>= 13.11.4),
+ debhelper-compat (= 13),
+ dh-apparmor,
+ libevdev-dev,
+ libinput-dev,
+ libwayland-dev,
+ libxkbcommon-dev,
+ pkgconf
 Homepage: https://github.com/vmonaco/kloak
 Vcs-Browser: https://github.com/vmonaco/kloak
 Vcs-Git: https://github.com/vmonaco/kloak.git
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 
 Package: kloak
@@ -30,7 +37,7 @@
 ## qemu:handle_cpu_signal received signal outside vCPU context @ pc=0x6000178c
 ## Update: Same as above.
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libevdev2, libsodium23
+Depends: ${shlibs:Depends}, ${misc:Depends}, python3
 Description: anti keystroke deanonymization tool
  A keystroke-level online anonymization kernel.
  .

=== debian/rules ===
--- 
+++ 
@@ -12,15 +12,13 @@
 %:
 	dh $@
 
-APPARMOR_PROFILE_NAME=$(shell basename $$(echo ./etc/apparmor.d/*.*))
-
 override_dh_installman:
-	dh_installman $(CURDIR)/debian/eventcap.8
 	dh_installman $(CURDIR)/debian/kloak.8
 
 override_dh_installchangelogs:
 	dh_installchangelogs changelog.upstream upstream
 
 override_dh_install:
-	dh_apparmor --profile-name=$(APPARMOR_PROFILE_NAME) -p$(shell dh_listpackages)
+	dh_apparmor --profile-name=usr.bin.kloak
+	dh_apparmor --profile-name=usr.libexec.kloak.find_wl_compositor
 	dh_install

## kloak 0.5.5

=== Makefile ===
--- 
+++ 
@@ -28,7 +28,6 @@
 # -fhardened             # superfluous when building an apt package
 #
 # Added the following flags:
-# -fsanitize=address,undefined # enable ASan/UBSan
 # -ftrapv                      # Crash on signed integer overflow/underflow
 # lots of additional warning flags and hardening
 WARN_CFLAGS := -Wall -Wextra -Wformat -Wformat=2 -Wconversion \
@@ -60,8 +59,7 @@
 FORTIFY_CFLAGS := -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=3 \
 	-fstack-clash-protection -fstack-protector-all \
 	-fno-delete-null-pointer-checks -fno-strict-overflow -fno-strict-aliasing \
-	-fsanitize=address,undefined -fno-sanitize-recover=all \
-	-fstrict-flex-arrays=3
+	-fstrict-flex-arrays=3 -ftrapv
 
 ifeq (yes,$(patsubst x86_64%-linux-gnu,yes,$(TARGETARCH)))
 FORTIFY_CFLAGS += -fcf-protection=full # only supported on x86_64

=== debian/changelog ===
kloak (0:0.5.5-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Fri, 10 Oct 2025 09:56:15 +0000

kloak (0:0.5.4-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Tue, 07 Oct 2025 08:41:26 +0000

=== debian/control ===
--- 
+++ 
@@ -44,3 +44,5 @@
  A privacy tool that makes keystroke biometrics less effective. This
  is accomplished by obfuscating the time intervals between key press and
  release events, which are typically used for identification.
+ .
+ https://www.whonix.org/wiki/Keystroke_and_Mouse_Deanonymization#Kloak

## kloak 0.6.4

=== debian/changelog ===
kloak (0:0.6.4-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Mon, 16 Feb 2026 10:34:35 +0000

kloak (0:0.6.3-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Fri, 16 Jan 2026 12:12:12 +0000

kloak (0:0.6.2-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Sun, 11 Jan 2026 16:44:34 +0000

kloak (0:0.6.1-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Wed, 03 Dec 2025 08:36:12 +0000

kloak (0:0.6.0-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Sun, 09 Nov 2025 09:18:40 +0000

kloak (0:0.5.9-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Sun, 09 Nov 2025 09:10:40 +0000

kloak (0:0.5.8-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Sun, 09 Nov 2025 08:19:00 +0000

kloak (0:0.5.7-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Fri, 31 Oct 2025 14:40:59 +0000

kloak (0:0.5.6-1) unstable; urgency=medium

  * New upstream version (local package).

 -- Patrick Schleizer <adrelanos@whonix.org>  Mon, 27 Oct 2025 11:52:36 +0000
